﻿[xml]$xaml = @"
<Window
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        x:Name="Window"
            Title="Office 365 Management" Height="779.138" Width="663.619">
    <Grid>
        <Label Content="Script ecrit par et pour AC-Tech - acsoyez.fr" HorizontalAlignment="Left" Margin="10,10,0,0" VerticalAlignment="Top" Width="636" FontStyle="Italic" Foreground="Red"/>
        <Rectangle Fill="#FFC7C7FD" HorizontalAlignment="Left" Height="60" Margin="10,55,0,0" Stroke="#FF000CFF" VerticalAlignment="Top" Width="636"/>
        <Label Content="Se connecter à O365" HorizontalAlignment="Left" Margin="10,55,0,0" VerticalAlignment="Top" FontStyle="Italic"/>
        <TextBox x:Name="Login" Text="Login" HorizontalAlignment="Left" Height="23" Margin="17,79,0,0" TextWrapping="Wrap" VerticalAlignment="Top" Width="139"/>
        <PasswordBox x:Name="PwD" HorizontalAlignment="Left" Margin="161,79,0,0" VerticalAlignment="Top" Width="99" Height="23"/>
        <Button x:Name="BtConnect" Content="Connexion" HorizontalAlignment="Left" Margin="265,79,0,0" VerticalAlignment="Top" Width="70" Height="23" Background="White" BorderBrush="#FF002EFF" Foreground="#FF0023FF"/>
        <ListBox x:Name="ListeCred" HorizontalAlignment="Left" Height="46" Margin="340,62,0,0" VerticalAlignment="Top" Width="300" Background="{x:Null}"/>
        <Rectangle Fill="#FFCEFDC7" HorizontalAlignment="Left" Height="115" Margin="10,123,0,0" Stroke="#FF085500" VerticalAlignment="Top" Width="636"/>
        <ListBox x:Name="ListeUser" HorizontalAlignment="Left" Height="87" Margin="17,144,0,0" VerticalAlignment="Top" Width="300"/>
        <Label Content="Liste des Utilisateurs" HorizontalAlignment="Left" Margin="10,123,0,0" VerticalAlignment="Top" FontStyle="Italic" FontSize="10"/>
        <Button x:Name="BtCheckUser" Content=">>" HorizontalAlignment="Left" Margin="322,173,0,0" VerticalAlignment="Top" Width="33" BorderBrush="#FF085500" Background="White" Foreground="#FF085500"/>
        <ListBox x:Name="UserDetail" HorizontalAlignment="Left" Height="87" Margin="360,144,0,0" VerticalAlignment="Top" Width="212" FontSize="10"/>
        <Label x:Name="Lbl_CheckUser" Content="" HorizontalAlignment="Left" Margin="322,188,0,0" VerticalAlignment="Top" Width="75"/>
        <Button x:Name="BtDeleteUser"  Content="Delete User" HorizontalAlignment="Left" Margin="577,167,0,0" VerticalAlignment="Top" Width="63" Background="#FFFFB7B7" BorderBrush="Red" Foreground="Red" FontStyle="Italic" FontWeight="Bold" FontSize="10" Height="33"/>
        <Button x:Name="Bt_Refresh" Content="Bt_Refresh" HorizontalAlignment="Left" Margin="242,126,0,0" VerticalAlignment="Top" Width="75" FontStyle="Italic" FontSize="10" Background="White" BorderBrush="#FF085500" Foreground="#FF085500"/>
        <Rectangle Fill="#FFB2E2FD" HorizontalAlignment="Left" Height="115" Margin="10,243,0,0" Stroke="#FF04A5FF" VerticalAlignment="Top" Width="636"/>
        <Label Content="Utilisateurs à la corbeille" HorizontalAlignment="Left" Margin="10,243,0,0" VerticalAlignment="Top" FontStyle="Italic" FontSize="10"/>
        <ListBox x:Name="ListeUserDeleted" HorizontalAlignment="Left" Height="87" Margin="17,266,0,0" VerticalAlignment="Top" Width="300"/>
        <ListBox x:Name="DelUserDetail" HorizontalAlignment="Left" Height="87" Margin="360,266,0,0" VerticalAlignment="Top" Width="212" FontSize="10"/>
        <Button x:Name="Bt_CheckDelUser" Content=">>" HorizontalAlignment="Left" Margin="322,297,0,0" VerticalAlignment="Top" Width="33" BorderBrush="#FF085500" Background="White" Foreground="#FF085500"/>
        <Button x:Name="Bt_DelUser_Resume"  Content="Resume User" HorizontalAlignment="Left" Margin="577,287,0,0" VerticalAlignment="Top" Width="63" Background="#FFFFB7B7" BorderBrush="Red" Foreground="Red" FontStyle="Italic" FontWeight="Bold" FontSize="10" Height="40"/>
        <Rectangle Fill="#FFFAFDB2" HorizontalAlignment="Left" Height="180" Margin="10,363,0,0" Stroke="#FF878D00" VerticalAlignment="Top" Width="636"/>
        <Label Content="Ajouter un utilisateur" HorizontalAlignment="Left" Margin="10,363,0,0" VerticalAlignment="Top" FontStyle="Italic" FontSize="10"/>
        <Label Content="Prénom" HorizontalAlignment="Left" Margin="10,387,0,0" VerticalAlignment="Top"/>
        <TextBox x:Name="AddUser_FirstName" HorizontalAlignment="Left" Height="23" Margin="87,390,0,0" TextWrapping="Wrap" Text="" VerticalAlignment="Top" Width="156"/>
        <Label Content="Nom" HorizontalAlignment="Left" Margin="10,415,0,0" VerticalAlignment="Top"/>
        <TextBox x:Name="AddUser_LastName" HorizontalAlignment="Left" Height="23" Margin="87,418,0,0" TextWrapping="Wrap" Text="" VerticalAlignment="Top" Width="156"/>
        <Label Content="Department" HorizontalAlignment="Left" Margin="12,442,0,0" VerticalAlignment="Top"/>
        <TextBox x:Name="AddUser_Department" HorizontalAlignment="Left" Height="23" Margin="87,446,0,0" TextWrapping="Wrap" Text="" VerticalAlignment="Top" Width="156"/>
        <Label Content="Ville" HorizontalAlignment="Left" Margin="12,470,0,0" VerticalAlignment="Top"/>
        <TextBox x:Name="AddUser_City" HorizontalAlignment="Left" Height="23" Margin="87,474,0,0" TextWrapping="Wrap" Text="" VerticalAlignment="Top" Width="156"/>
        <Button x:Name="Bt_CheckCreateUser" Content="Check" HorizontalAlignment="Left" Margin="255,390,0,0" VerticalAlignment="Top" Width="52" Background="{x:Null}" BorderBrush="#FF878D00" Foreground="#FF878D00" Height="23"/>
        <Button x:Name="Bt_CreateUser" Content="Create User" HorizontalAlignment="Left" Margin="577,369,0,0" VerticalAlignment="Top" Width="63" Background="#FFFFB7B7" BorderBrush="Red" Foreground="Red" FontStyle="Italic" FontWeight="Bold" FontSize="10" Height="34"/>
        <ListBox x:Name="Lbl_CheckCreateUser" HorizontalAlignment="Left" Height="124" Margin="322,369,0,0" VerticalAlignment="Top" Width="250"/>
        <Label x:Name="Lbl_Creation" Content="" HorizontalAlignment="Left" Margin="255,498,0,0" VerticalAlignment="Top" Height="36" Width="385"/>
        <Label Content="Domaine" HorizontalAlignment="Left" Margin="12,498,0,0" VerticalAlignment="Top"/>
        <TextBox x:Name="AddUser_Domaine" HorizontalAlignment="Left" Height="23" Margin="87,502,0,0" TextWrapping="Wrap" Text="acsoyez.fr" VerticalAlignment="Top" Width="156"/>
        <Button x:Name="Bt_CorrectCreateUser" Content="Correct" HorizontalAlignment="Left" Margin="255,418,0,0" VerticalAlignment="Top" Width="52" Background="{x:Null}" BorderBrush="#FF878D00" Foreground="#FF878D00" Height="23"/>
        <Rectangle Fill="#FFFDCDB2" HorizontalAlignment="Left" Height="190" Margin="12,548,0,0" Stroke="#FF8D4000" VerticalAlignment="Top" Width="634"/>
        <Label Content="Affecter une licence" HorizontalAlignment="Left" Margin="12,548,0,0" VerticalAlignment="Top" FontStyle="Italic" FontSize="10" Foreground="#FF8D4000"/>
        <Label Content="Licences Disponibles" HorizontalAlignment="Left" Margin="17,568,0,0" VerticalAlignment="Top"/>
        <ListBox x:Name="ListeLicenceAvailable" HorizontalAlignment="Left" Height="61" Margin="17,588,0,0" VerticalAlignment="Top" Width="226"/>
        <Label Content="User sans licence" HorizontalAlignment="Left" Margin="255,568,0,0" VerticalAlignment="Top"/>
        <ListBox x:Name="ListeUserWithoutLicence" HorizontalAlignment="Left" Height="61" Margin="255,588,0,0" VerticalAlignment="Top" Width="255"/>
        <Button x:Name="Bt_CheckSelectionLicence" Content="Check" HorizontalAlignment="Left" Margin="191,656,0,0" VerticalAlignment="Top" Width="52" Background="{x:Null}" BorderBrush="#FF8D4000" Foreground="#FF8D4000" Height="23"/>
        <Button x:Name="Bt_AssignLicence" Content="Assign" HorizontalAlignment="Left" Margin="458,656,0,0" VerticalAlignment="Top" Width="52" Background="#FFFFB7B7" BorderBrush="Red" Foreground="Red" Height="23"/>
        <Label x:Name="Lbl_AssignLicence" Content="" HorizontalAlignment="Left" Margin="87,684,0,0" VerticalAlignment="Top" Height="42" Width="423"/>
        <Button x:Name="Bt_ModifySelectionLicence" Content="Modify" HorizontalAlignment="Left" Margin="255,656,0,0" VerticalAlignment="Top" Width="52" Background="{x:Null}" BorderBrush="#FF8D4000" Foreground="#FF8D4000" Height="23"/>
    </Grid>
</Window>
"@

#**************************************************************
# Permet de lancer le script
# sans devoir passer par Windows PowerShell ISE
#**************************************************************
[void][System.Reflection.Assembly]::LoadWithPartialName('presentationframework')

#**************************************************************
#Changement du XAML et et création de la fenêtre
#**************************************************************
$reader = (New-Object System.Xml.XmlNodeReader $xaml)
$window = [Windows.Markup.XamlReader]::Load($reader)

#**************************************************************
# Définition des variables en fonction des noms des éléments
#**************************************************************
$Login = $window.FindName("Login")
$PwD = $window.FindName("PwD")
$BtConnect = $window.FindName("BtConnect")
$ListeCred = $window.FindName("ListeCred")
$ListeUser = $window.FindName("ListeUser")
$BtCheckUser = $window.FindName("BtCheckUser")
$Lbl_CheckUser = $window.FindName("Lbl_CheckUser")
$UserDetail = $window.FindName("UserDetail")
$BtDeleteUser = $window.FindName("BtDeleteUser")
$Bt_Refresh = $window.FindName("Bt_Refresh")
$ListeUserDeleted = $window.FindName("ListeUserDeleted")
$DelUserDetail = $window.FindName("DelUserDetail")
$Bt_CheckDelUser = $window.FindName("Bt_CheckDelUser")
$Bt_DelUser_Resume = $window.FindName("Bt_DelUser_Resume")
$AddUser_FirstName = $window.FindName("AddUser_FirstName")
$AddUser_LastName = $window.FindName("AddUser_LastName")
$AddUser_Department = $window.FindName("AddUser_Department")
$AddUser_City = $window.FindName("AddUser_City")
$Bt_CheckCreateUser = $window.FindName("Bt_CheckCreateUser")
$Bt_CreateUser = $window.FindName("Bt_CreateUser")
$Lbl_CheckCreateUser = $window.FindName("Lbl_CheckCreateUser")
$Lbl_Creation = $window.FindName("Lbl_Creation")
$AddUser_Domaine = $window.FindName("AddUser_Domaine")
$Bt_CorrectCreateUser = $window.FindName("Bt_CorrectCreateUser")
$ListeLicenceAvailable = $window.FindName("ListeLicenceAvailable")
$ListeUserWithoutLicence = $window.FindName("ListeUserWithoutLicence")
$Bt_CheckSelectionLicence = $window.FindName("Bt_CheckSelectionLicence")
$Bt_AssignLicence = $window.FindName("Bt_AssignLicence")
$Lbl_AssignLicence = $window.FindName("Lbl_AssignLicence")
$Bt_ModifySelectionLicence = $window.FindName("Bt_ModifySelectionLicence")

#**************************************************************
# Fonction de recharges des listes et effacement des sélections
#**************************************************************
function RefreshListes 
{ 
    #Effacement des listes affichées
    $ListeUser.Items.Clear()
    $ListeUserDeleted.Items.Clear()
    $UserDetail.Items.Clear()
    $DelUserDetail.Items.Clear()
    $ListeLicenceAvailable.Items.Clear()
    $ListeUserWithoutLicence.Items.Clear()

    #Chargement de la liste des users
    $ListUsers = Get-MsolUser | Sort-Object -property DisplayName
    Foreach ($user in $ListUsers)
    {
        $ListeUser.Items.Add($user.UserPrincipalName)
    }
    $ListeUserDeleted.Items.Clear()
    $DelUsers = Get-MsolUser -All -ReturnDeletedUsers
    #Affiche dans la liste les utlisateurs qui se trouvent dans la corbeille
    Foreach ($DelUser in $DelUsers)
    {
        $ListeUserDeleted.Items.Add($DelUser.UserPrincipalName)
    }

    #chargement de la liste de licences
    $ListLicences = Get-MsolAccountSku
    Foreach ($Licence in $ListLicences)
    {
        $ListeLicenceAvailable.Items.Add($Licence.AccountSkuId)
    }

    #chargement de la liste des users sans licences
    $ListeUserUnlicensed = Get-MsolUser -UnlicensedUsersOnly
    Foreach ($UserUnlicensed in $ListeUserUnlicensed)
    {
        $ListeUserWithoutLicence.Items.Add($UserUnlicensed.UserPrincipalName)
    }
}

#**************************************************************
# PARTIE VIOLETTE: Connection au Tenant Office 365
#**************************************************************
$BtConnect.add_Click({
    Import-module msonline
    $username = $Login.Text
    #Récupération du camp Password et conversion en SecurePassword
    $SecurePWD = ConvertTo-SecureString -String $PWD.Password.ToString() -AsPlainText -Force
    #Création des crédentials pour la connexion au Tenant O365
    $cred = new-object -typename System.Management.Automation.PSCredential -argumentlist $username, $SecurePWD
    #Connexion au Tenant O365
    Connect-MsolService -Credential $Cred
    #Récupération du Role de l'utilisateur
    $CredRole = Get-MsolUserRole -UserPrincipalName $username
    #Récupération du Nom complet de l'utilisateur Authentifié
    $CredUser = Get-MsolUser -UserPrincipalName $username
    #Affichage du Nom et du Role dans la ListeBox
    $ListeCred.Items.Add("Bonjour "+$CredUser.DisplayName+" !")
    $ListeCred.Items.Add("Vous êtes "+$CredRole.Name)
    #Peupler les listes utilisateurs
    RefreshListes
})

#**************************************************************
# PARTIE VERTE: Liste user et Supression d'un user
#**************************************************************
#Détail d'un utilisateur sélectionné dans la liste
$BtCheckUser.add_Click({
    #Efface la liste des détails
    $UserDetail.Items.Clear()
    #Récupération des informations liées à l'utilisateur sélectionné
    $SelectedUser = Get-MsolUser -UserPrincipalName $ListeUser.SelectedItem
    
    $UserDetail.Items.Add("UserPrincipalName : "+$SelectedUser.UserPrincipalName)
    $UserDetail.Items.Add("Prénom : "+$SelectedUser.Firstname)
    $UserDetail.Items.Add("Nom : "+$SelectedUser.Lastname)
    $UserDetail.Items.Add("Licenced : "+$SelectedUser.isLicensed)
})

#Supression de l'utilisateur séléectionné
$BtDeleteUser.add_Click({ 
    Remove-MsolUser -UserPrincipalName $ListeUser.SelectedItem
    RefreshListes
})

#Refresh de la liste des utilisateurs actifs
$Bt_Refresh.add_Click({ 
    RefreshListes
})

#**************************************************************
# PARTIE BLEUE: Corbeille et Restauration
#**************************************************************
#Détail d'un utilisateur sélectionner dans la liste
$Bt_CheckDelUser.add_Click({
    #Efface la liste des détails
    $DelUserDetail.Items.Clear()
    #Récupération des informations liées à l'utilisateur sélectionné
    $SelectedDelUser = Get-MsolUser -UserPrincipalName $ListeUserDeleted.SelectedItem -ReturnDeletedUsers
    #Affichage des informations dans la ListeBox
    $DelUserDetail.Items.Add("UserPrincipalName : "+$SelectedDelUser.UserPrincipalName)
    $DelUserDetail.Items.Add("Prénom : "+$SelectedDelUser.Firstname)
    $DelUserDetail.Items.Add("Nom : "+$SelectedDelUser.Lastname)
    $DelUserDetail.Items.Add("Licenced : "+$SelectedDelUser.isLicensed)
})

#Restauration de l'utilisateur sélectionné
$Bt_DelUser_Resume.add_Click({
    #Restauration de l'utilisateur séléectionné
    Restore-MsolUser -UserPrincipalName $ListeUserDeleted.SelectedItem
    RefreshListes
})

#**************************************************************
# PARTIE JAUNE: Création d'un utilisateur
#**************************************************************
<# Variable disponible
$AddUser_FirstName
$AddUser_LastName
$AddUser_Department
$AddUser_City
$Bt_CheckCreateUser
$Bt_CreateUser
$Lbl_CheckCreateUser
$Lbl_Creation
$AddUser_Domaine
$Bt_CorrectCreateUser
#>

$Bt_CheckCreateUser.add_Click({
    #Effacement des labels
    $Lbl_Creation.Content = ""
    $creation = ""

    #Ecriture des éléments dans la ListBox de Check
    $Lbl_CheckCreateUser.Items.add("P: "+$AddUser_FirstName.Text)
    $Lbl_CheckCreateUser.Items.add("N: "+$AddUser_LastName.Text)
    $Lbl_CheckCreateUser.Items.add("D: "+$AddUser_Department.Text)
    $Lbl_CheckCreateUser.Items.add("V: "+$AddUser_City.Text)

    #Bloquage des champs entrés
    $AddUser_FirstName.IsEnabled = $false
    $AddUser_LastName.IsEnabled = $false
    $AddUser_Department.IsEnabled = $false
    $AddUser_City.IsEnabled = $false
    $AddUser_Domaine.IsEnabled = $false
    
    #Récupération du premier caractère du prénom
    $PreMail = ($AddUser_FirstName.Text).Substring(0,1)
    
    #Création de l'adresse mail
    $AddUserMail = ($PreMail+"."+$AddUser_LastName.Text+"@"+$AddUser_Domaine.Text).ToLower()

    $Lbl_CheckCreateUser.Items.add($AddUserMail)

    $Lbl_CheckCreateUser.Items.add("DisplayName : "+$AddUser_FirstName.Text+" "+$AddUser_LastName.Text)

    $creation = "ready"

})

#réactivation des champs pour modifier les informations
$Bt_CorrectCreateUser.add_Click({

    $AddUser_FirstName.IsEnabled = $true
    $AddUser_LastName.IsEnabled = $true
    $AddUser_Department.IsEnabled = $true
    $AddUser_City.IsEnabled = $true
    $AddUser_Domaine.IsEnabled = $true

    $Lbl_Creation.Content = ""
    $Lbl_CheckCreateUser.Items.Clear()
})

#création de l'utilisateur dans le tenant Office 365
$Bt_CreateUser.add_Click({

    $Lbl_Creation.Content = ""

    
    if ($creation = "ready")
    {
        #recrétion de l'adresse mail
        $PreMail = ($AddUser_FirstName.Text).Substring(0,1)
        $AddUserMail = ($PreMail+"."+$AddUser_LastName.Text+"@"+$AddUser_Domaine.Text).ToLower()

        #injection de l'utilisateur dans Office365
        $DisplayName = $AddUser_FirstName.Text+" "+$AddUser_LastName.Text
        New-MsolUser -UserPrincipalName $AddUserMail -DisplayName $DisplayName -LastName $AddUser_LastName.Text -FirstName $AddUser_FirstName.Text -UsageLocation "FR" -City $AddUser_City -Department $AddUser_Department 
        
        $Lbl_Creation.Content = "Utilisateur créé : "+$AddUserMail

        #Rafraichissement des listes pour faire apparaitre le nouvel utilisateur dans la liste
        RefreshListes
    }
    else
    {
       $Lbl_Creation.Content = "Vous devez vérifier les informations avec le bouton CHECK." 
    }
})

#**************************************************************
# Affichage de la fenêtre
#**************************************************************
$window.ShowDialog()
